const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const genres = sequelize.define(
    'genres',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

origin: {
        type: DataTypes.ENUM,
      
      

        values: [

"south_africa",


"global"

        ],

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

typical_bpm_min: {
        type: DataTypes.INTEGER,
      
      

      },

typical_bpm_max: {
        type: DataTypes.INTEGER,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  genres.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity











    db.genres.hasMany(db.projects, {
      as: 'projects_primary_genre',
      foreignKey: {
          name: 'primary_genreId',
      },
      constraints: false,
    });



    db.genres.hasMany(db.songs, {
      as: 'songs_genre',
      foreignKey: {
          name: 'genreId',
      },
      constraints: false,
    });







    db.genres.hasMany(db.generation_requests, {
      as: 'generation_requests_target_genre',
      foreignKey: {
          name: 'target_genreId',
      },
      constraints: false,
    });


    db.genres.hasMany(db.vocal_processing_presets, {
      as: 'vocal_processing_presets_recommended_genre',
      foreignKey: {
          name: 'recommended_genreId',
      },
      constraints: false,
    });


    db.genres.hasMany(db.mastering_presets, {
      as: 'mastering_presets_genre',
      foreignKey: {
          name: 'genreId',
      },
      constraints: false,
    });






    db.genres.hasMany(db.marketplace_listings, {
      as: 'marketplace_listings_genre',
      foreignKey: {
          name: 'genreId',
      },
      constraints: false,
    });




//end loop



    db.genres.belongsTo(db.genres, {
      as: 'parent_genre',
      foreignKey: {
        name: 'parent_genreId',
      },
      constraints: false,
    });

    db.genres.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.genres.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.genres.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return genres;
};


